/****************************************************************************
				 Tag.c
 Program to move the user gender and location into the sysop
 notes. This allows the real/validated sex of the subscriber 
 to be displayed in user logs.

(Clone of ALLUSERS.C program from Digital Dynamics )
****************************************************************************/

#include <io.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/stat.h>

#include "defs.h"


/****************************************************************************/
/* Truncates white-space chars off end of 'str' and terminates at first tab */
/****************************************************************************/
void truncsp(char *str)
{
	char c;

str[strcspn(str,"\t")]=0;
c=strlen(str);
while(c && (uchar)str[c-1]<=SP) c--;
str[c]=0;
}

/****************************************************************************/
/* Network open function. Opens all files DENYALL and retries LOOP_NOPEN    */
/* number of times if the attempted file is already open or denying access  */
/* for some other reason.	All files are opened in BINARY mode.			*/
/****************************************************************************/
int nopen(char *str, int access)
{
	char logstr[256];
	int file,share,count=0;

if(access==O_RDONLY) share=O_DENYWRITE;
	else share=O_DENYALL;
while(((file=open(str,O_BINARY|share|access,S_IWRITE))==-1)
	&& errno==EACCES && count++<LOOP_NOPEN)
	if(count>10)
		delay(55);
if(file==-1 && errno==EACCES)
	printf("\7\nNOPEN: ACCESS DENIED\n\7");
return(file);
}
/******************************************************************/

int main()
{
char 	str[128],loc[128],note[128];
long	file,offset,length;
FILE	*stream;

		sprintf(str,"/SBBS/DATA/USER/USER.DAT");
		if((file=nopen(str,O_RDWR))==-1) {
			printf("Error opening %s\n",str);
			exit(1); }
		if((stream=fdopen(file,"w+b"))==NULL) {
			printf("Error opening %s\n",str);
			exit(1); }
		setvbuf(stream,NULL,_IOFBF,2048);
		length=filelength(file);
		for(offset=0;offset<length;offset+=U_LEN) {
			printf("%lu\r", offset/U_LEN+1);
			fseek(stream,offset+U_SEX,SEEK_SET);
			fread(str,2,1,stream);
			fseek(stream,offset+U_LOCATION,SEEK_SET);
			fread(loc,30,1,stream);
			truncsp(loc);
			str[30]=0;
			if(str[0]=='M')
			{
				loc[14]=0;
				sprintf(note,"-cMalen-%s",loc);
			}
			else 
				if(str[0]=='F')
				{
					loc[12]=0;
					sprintf(note,"-yFemalen-%s ",loc);
				}
				else
				{
					printf("\r\nError in record \r\n");	
					fclose(stream);
					exit(1);
				}
			fseek(stream,offset+U_NOTE,SEEK_SET);
			fwrite(note,30,1,stream);
			}
		fclose(stream);
		printf("\r\n");
return(0);
}
